﻿@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using System.Web.UI.WebControls;
@using Portal.Controllers;
@using Portal.Models.Globals;
@using Portal.Models.RetroInquiry;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.Credential;


@Html.DevExpress().GridView(
    setting => {
        setting.Name = "GridRetroInquiryDetail";
        setting.KeyFieldName = "RETRO_DOC_NO";
        setting.CallbackRouteValues = new { Controller = "RetroInquiry", Action = "ReloadGridDetailData" };
        setting.ClientSideEvents.BeginCallback = "OnBeginCallback";
        setting.Width = System.Web.UI.WebControls.Unit.Percentage(100);
        setting.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        //setting.Settings.VerticalScrollBarMode = ScrollBarMode.Visible;
        setting.Settings.HorizontalScrollBarMode= ScrollBarMode.Hidden;

        setting.SettingsBehavior.AllowDragDrop = false;
        setting.Settings.ShowFilterRow = true;
        setting.Settings.ShowFilterRowMenu = true;

        setting.SettingsPager.PageSizeItemSettings.Visible = true;
        setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
        setting.SettingsPager.PageSizeItemSettings.Caption = "Page Size";

        setting.Columns.Add(
        column =>
        {
            column.Name = "ActionEdit";
            column.Caption = "Edit";
            column.CellStyle.Wrap = DefaultBoolean.True;
            
            column.Width = Unit.Pixel(50);
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
            column.SetDataItemTemplateContent(
                content =>
                {
                    Html.DevExpress().HyperLink(
                        label =>
                        {
                            label.Properties.ImageUrl = Url.Content("~/Content/Images/Common/Edit.png");
                            label.NavigateUrl = "javascript:void(0)";
                            label.Name = "LnkEditGrid_" + content.VisibleIndex;
                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                            label.Properties.ClientSideEvents.Click = String.Format("function(s, e) {{ OnEditGrid(s, e, {0}); }}", content.VisibleIndex);
                        }).Render();
                    
                    Html.DevExpress().HyperLink(
                        label =>
                        {
                            label.Properties.ImageUrl = Url.Content("~/Content/Images/Common/Check.png");
                            label.NavigateUrl = "javascript:void(0)";
                            label.Name = "LnkUpdateGrid_" + content.VisibleIndex;
                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                            label.Properties.ClientSideEvents.Click = String.Format("function(s, e) {{ OnUpdateGrid(s, e, {0}); }}", content.VisibleIndex);
                            label.ClientVisible = false;
                        }).Render();
                    
                    Html.DevExpress().HyperLink(
                        label =>
                        {
                            label.Properties.ImageUrl = Url.Content("~/Content/Images/Common/Delete.png");
                            label.NavigateUrl = "javascript:void(0)";
                            label.Name = "LnkCancelGrid_" + content.VisibleIndex;
                            label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                            label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                            label.Properties.ClientSideEvents.Click = String.Format("function(s, e) {{ OnCancelGrid(s, e, {0}); }}", content.VisibleIndex);
                            label.ClientVisible = false;
                        }).Render();
                });
            // authorization code
            int auth = Model.GetModel<Toyota.Common.Web.Credential.User>().IsAuthorized("RetroInquiry", "ActionEdit");
            switch (auth)
            {
                case 0:
                    column.Visible = false;
                    break;
                case 1:
                    column.Visible = false;
                    break;
                case 2:
                    column.Visible= true;
                    break;
                default:
                    column.Visible= true;
                    break;
            }
            
        });
        
        setting.Columns.Add(
            col =>
            {
                col.Name = "RetroDoc";
                col.Caption = "Retro Doc No.";
                col.FieldName = "RETRO_DOC_NO";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(80);
                
                col.SetDataItemTemplateContent(
                    c => {
                        Html.DevExpress().HyperLink(hlSettings =>
                        {
                            hlSettings.Name = string.Format("LblRetroDoc_{0}", (c as GridViewDataItemTemplateContainer).VisibleIndex);
                            hlSettings.ClientVisible = true;
                            hlSettings.NavigateUrl = "javascript:void(0)";
                            hlSettings.Properties.ClientSideEvents.Click =
                                string.Format("function(s, e) {{ OnHyperLinkClick('{0}'); }}", (c as GridViewDataItemTemplateContainer).Text);
                            hlSettings.Properties.Text = (c as GridViewDataItemTemplateContainer).Text;
                        }).Render();
                });
            });

        setting.Columns.AddBand(
            band => {
                band.Caption = "Period";
                band.Columns.Add(
                    col => {
                        col.Name = "PeriodeFrom";
                        col.Caption = "From";
                        col.FieldName = "PERIOD_FROM";
                        col.ColumnType = MVCxGridViewColumnType.DateEdit;
                        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                        col.Width = Unit.Pixel(80);
                    });
                band.Columns.Add(
                    col =>
                    {
                        col.Name = "PeriodeTo";
                        col.Caption = "To";
                        col.FieldName = "PERIOD_TO";
                        col.ColumnType = MVCxGridViewColumnType.DateEdit;
                        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                        col.Width = Unit.Pixel(80);
                    });
            });

        setting.Columns.Add(
            col =>
            {
                col.Name = "Currency";
                col.Caption = "Currency";
                col.FieldName = "CURRENCY_CD";
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(50);
                col.PropertiesEdit.DisplayFormatString = "{0:###,###.##}";
                
                var combosetting = col.PropertiesEdit as ComboBoxProperties;
                IEnumerable<Currency> currency = Model.GetModel<IEnumerable<Currency>>();
                if (currency.Count() > 0)
                    currency.ToList().ForEach(s => combosetting.Items.Add(s.CURRENCY_CD));
            });

        setting.Columns.Add(
            col =>
            {
                col.Name = "Amount";
                col.Caption = "Amount";
                col.FieldName = "RETRO_AMOUNT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(120);
                col.PropertiesEdit.NullDisplayText = "0";
                col.PropertiesEdit.DisplayFormatString = "{0:###,###.##}";
            });

        setting.Columns.Add(
            col =>
            {
                //col.Name = "RetroRate";
                col.Caption = "Retro<br>Rate";
                col.FieldName = "RETRO_RATE";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
                col.ColumnType = MVCxGridViewColumnType.TextBox;

             col.SetDataItemTemplateContent(
                 c =>
                 {
                    Html.DevExpress().Label(lblSettings =>
                    {
                        lblSettings.Name = string.Format("LblRetroRate_{0}", c.VisibleIndex);
                        lblSettings.Text = DataBinder.Eval(c.DataItem, c.Column.FieldName) == null ? "" : DataBinder.Eval(c.DataItem, c.Column.FieldName).ToString();
                        lblSettings.ClientVisible = true;
                        lblSettings.Properties.EnableClientSideAPI = true;
                    }).Render();
                    Html.DevExpress().TextBox(lblSettings =>
                    {
                        lblSettings.Name = string.Format("TxtRetroRate_{0}", c.VisibleIndex);
                        lblSettings.Text = (string)DataBinder.Eval(c.DataItem, c.Column.FieldName);
                        lblSettings.ClientVisible = false;
                        lblSettings.Width = Unit.Percentage(100);
                        lblSettings.Properties.Style.HorizontalAlign = HorizontalAlign.Center;
                        lblSettings.Text = DataBinder.Eval(c.DataItem, c.Column.FieldName) == null ? "" : DataBinder.Eval(c.DataItem, c.Column.FieldName).ToString();
                    }).Render();
                });
            });
        
        setting.Columns.Add(
            col =>
            {
                col.Name = "SupplierCode";
                col.Caption = "Supplier<br>Code";
                col.FieldName = "SUPPLIER_CD";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(60);
            });

        setting.Columns.Add(
            col =>
            {
                col.Name = "SupplierName";
                col.Caption = "Supplier Name";
                col.FieldName = "SUPPLIER_NAME";
                col.Width = Unit.Pixel(180);
            });

        setting.Columns.AddBand(
            band =>
            {
                band.Caption = "Retro Payment";
                band.Columns.Add(
                    col =>
                    {
                        col.Name = "InvoiceNo";
                        col.Caption = "Invoice No";
                        col.FieldName = "REMAINING_INV_NO";
                        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        col.Width = Unit.Pixel(80);

                        col.SetDataItemTemplateContent(
                        c =>
                        {
                            Html.DevExpress().Label(lblSettings =>
                            {
                                lblSettings.Name = string.Format("LblInvoiceNo_{0}", c.VisibleIndex);
                                lblSettings.Text = DataBinder.Eval(c.DataItem, c.Column.FieldName) == null ? "" : DataBinder.Eval(c.DataItem, c.Column.FieldName).ToString();
                                lblSettings.Properties.EnableClientSideAPI = true;
                            }).Render();
                        });
                    });
                band.Columns.Add(
                    col =>
                    {
                        col.Name = "InvoiceDate";
                        col.Caption = "Invoice Date";
                        col.FieldName = "REMAINING_INV_DATE";
                        col.ColumnType = MVCxGridViewColumnType.DateEdit;
                        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        col.Width = Unit.Pixel(80);
                    });
                band.Columns.Add(
                    col =>
                    {
                        col.Name = "AmountPayment";
                        col.Caption = "Amount";
                        col.FieldName = "REMAINING_AMOUNT";
                        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        col.Width = Unit.Pixel(80);
                        //col.PropertiesEdit.NullDisplayText = "0";
                        col.PropertiesEdit.DisplayFormatString = "{0:###,###.##}";
                    });
            });
        
        setting.Columns.Add(
            col =>
            {
                col.Name = "RetroAmount";
                col.Caption = "Remaining<br>Amount";
                col.FieldName = "RETRO_REMAINING_AMOUNT";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.Width = Unit.Pixel(100);
                //col.PropertiesEdit.NullDisplayText = "0";
                col.PropertiesEdit.DisplayFormatString = "{0:###,###.##}";
            });

        setting.Columns.Add(
            col =>
            {
                col.Name = "RetroStatus";
                col.Caption = "Status";
                col.FieldName = "RETRO_STATUS";
                col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                col.ColumnType = MVCxGridViewColumnType.ComboBox;
                col.Width = Unit.Pixel(60);

                var cmbSetting = col.PropertiesEdit as ComboBoxProperties;
                cmbSetting.Items.Add("Closed");
                cmbSetting.Items.Add("Posted");
            });

        setting.Columns.Add(
            col =>
         {
             // field properties
             col.Caption = "Notice";
             col.Name = "NOTICE";
             col.FieldName = "NOTICE";

             col.Width = Unit.Pixel(50);
             col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
             col.CellStyle.VerticalAlign = VerticalAlign.Middle;

             col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
             col.ColumnType = MVCxGridViewColumnType.ComboBox;

             col.SetDataItemTemplateContent(
                 content =>
                 {
                     @Html.Common().DevExpress().MessageBoardOpenImage(
                         imgsettings =>
                         {
                             imgsettings.Name = "RetroInquiryMessage" + content.VisibleIndex;
                             imgsettings.BoardId = "RetroInquiryMessageBoard";
                             imgsettings.BoardName = "RetroInquiryBoard_" + DataBinder.Eval(content.DataItem, "RETRO_DOC_NO");
                         }).Render();
                 });

             // field filter properties
             var combosetting = col.PropertiesEdit as ComboBoxProperties;
             combosetting.Items.Add("Empty", "~/content/images/notice_add_icon.png", "~/content/images/notice_add_icon.png");
             combosetting.Items.Add("New", "~/content/images/notice_new_icon.png", "~/content/images/notice_new_icon.png");
             combosetting.Items.Add("Read", "~/content/images/notice_open_icon.png", "~/content/images/notice_open_icon.png");
             combosetting.Items.Add("Close", "~/content/images/notice_close_icon.png", "~/content/images/notice_close_icon.png");
         });
        
    }).Bind(Model.GetModel<List<RetroInquiryDetail>>()).GetHtml()